Imports System.Runtime.InteropServices

Module mdlMain

    Sub Main()

        Dim locLongEx As New LongEx(&HFEA912340000FFFFUL)
        Console.WriteLine("Value of locLongEx: " & locLongEx.Value.ToString("#,##0"))
        Console.WriteLine("Signed: " & locLongEx.SignedLong.ToString("#,##0"))
        Console.WriteLine("Upper unsigned integer part: " & locLongEx.HighUnsignedInt.ToString("#,##0"))
        Console.WriteLine("Lower unsigned integer part: " & locLongEx.LowUnsignedInt.ToString("#,##0"))
        Console.WriteLine("Upper singed integer part: " & locLongEx.HighSignedInt.ToString("#,##0"))
        Console.WriteLine("Lower signed integer part: " & locLongEx.LowSignedInt.ToString("#,##0"))
        Console.WriteLine()
        Console.WriteLine("Press any key to quit!")
        Console.ReadKey()
    End Sub

End Module

'Define that the order of the
'byte definitions must be followed strictly!
<StructLayout(LayoutKind.Explicit)> _
Public Structure LongEx
    <FieldOffset(0)> Private myUnsignedLong As ULong
    <FieldOffset(0)> Private mySignedLong As Long
    <FieldOffset(0)> Private myLowUnsignedInt As UInteger
    <FieldOffset(4)> Private myHighUnsignedInt As UInteger
    <FieldOffset(0)> Private myLowSignedInt As Integer
    <FieldOffset(4)> Private myHighSignedInt As Integer

    Sub New(ByVal Value As ULong)
        myUnsignedLong = Value
    End Sub

    Sub New(ByVal Value As Long)
        mySignedLong = Value
    End Sub

    Sub New(ByVal value As UInteger)
        myLowUnsignedInt = value
    End Sub

    Sub New(ByVal value As Integer)
        myLowSignedInt = value
    End Sub

    Public Property Value() As ULong
        Get
            Return myUnsignedLong
        End Get
        Set(ByVal value As ULong)
            myUnsignedLong = value
        End Set
    End Property

    Public ReadOnly Property SignedLong() As Long
        Get
            Return mySignedLong
        End Get
    End Property

    Public ReadOnly Property HighUnsignedInt() As UInteger
        Get
            Return myHighUnsignedInt
        End Get
    End Property

    Public ReadOnly Property LowUnsignedInt() As UInteger
        Get
            Return myLowUnsignedInt
        End Get
    End Property

    Public ReadOnly Property HighSignedInt() As Integer
        Get
            Return myHighSignedInt
        End Get
    End Property

    Public ReadOnly Property LowSignedInt() As Integer
        Get
            Return myLowSignedInt
        End Get
    End Property
End Structure


