Public Class frmEvents

    Private Sub Button1And2Events(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click, Button2.Click, Button3.Click
        'A MessageBox is displayed when the user triggers Button1, Button2, or Button3.
        MessageBox.Show(sender.ToString & " was clicked!", "Event handling result:")

        'Color the clicked button red.
        'ERROR! Not possible, because Sender has the type Object:
        'sender.Backcolor = Color.Red

        'This works, because there are only buttons,
        'therefore it's safe to cast in Button:
        Dim locClickedButton As Button
        locClickedButton = DirectCast(sender, Button)

        'Now it's possible to color the clicked button in red
        locClickedButton.BackColor = Color.Red
    End Sub

End Class
