﻿Public Class Contact

    Private myFirstName As String
    Private myLastName As String
    Private myZIP As String
    Private myCity As String

    Public Property FirstName() As String
        Get
            Return myFirstName
        End Get
        Set(ByVal value As String)
            myFirstName = value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return myLastName
        End Get
        Set(ByVal value As String)
            myLastName = value
        End Set
    End Property

    Public Property ZIP() As String
        Get
            Return myZIP
        End Get
        Set(ByVal value As String)
            myZIP = value
        End Set
    End Property

    Public Property City() As String
        Get
            Return myCity
        End Get
        Set(ByVal value As String)
            myCity = EllipseString(value, 30)
        End Set
    End Property

    Public Function ContactText() As String

        Return Me.LastName & ", " & Me.FirstName & ", " & _
                Me.ZIP & ", " & Me.City

    End Function

    Private Function EllipseString(ByVal text As String, ByVal MaxLength As Integer) As String

        Dim tmpText As String

        If text.Length > MaxLength Then
            tmpText = text.Substring(0, MaxLength - 3) + "..."
        Else
            tmpText = text
        End If
        Return tmpText
    End Function

End Class