Module mdlMain

    Sub Main()

        Dim class1 As New FirstClass
        class1.AValue = 5
        Console.WriteLine(class1.AsString())

        Dim class2 As New SecondClass
        class2.AValue = 5

        Console.WriteLine(class2.IncreasedBy10)
        Console.WriteLine()
        Console.WriteLine("Press any key to exit!")
        Console.ReadKey()
    End Sub

End Module

Class FirstClass

    Private myAValue As Integer = 9

    Sub New()
        'The following code line makes no sense but to fill the constructor with something.
        Console.WriteLine("WriteLine Test: Default Constructor")
    End Sub

    Sub New(somethingToWrite As String)
        'The following code line makes no sense but to fill the constructor with something.
        Console.WriteLine("WriteLine Test:" & somethingToWrite)
    End Sub

    'Property to change the value
    Property AValue() As Integer
        Get
            Return myAValue
        End Get
        Set(ByVal value As Integer)
            myAValue = value
        End Set
    End Property

    'Function, to convert the content to String.
    Public Overridable Function AsString() As String
        Return CStr(myAValue)
    End Function

End Class

Class SecondClass
    Inherits FirstClass

    Sub New()
        MyBase.new()
    End Sub

    ReadOnly Property IncreasedBy10 As Integer
        Get
            Return AValue + 10
        End Get
    End Property
End Class

