Interface IBaseInterface
    Property FirstProperty() As String
End Interface

Interface IMoreComplexInterface
    Property SecondProperty() As String
End Interface

Public Class ComplexClass
    Implements IBaseInterface, IMoreComplexInterface

    Public Property FirstProperty() As String Implements IBaseInterface.FirstProperty
        Get

        End Get
        Set(ByVal value As String)

        End Set
    End Property

    Public Property SecondProperty() As String Implements IMoreComplexInterface.SecondProperty
        Get

        End Get
        Set(ByVal value As String)

        End Set
    End Property
End Class

Interface ITest
    Function FirstMethod() As Integer
    Function SecondMethod() As String
    Function ToString() As String
End Interface

Public MustInherit Class AbstractTest
    Public MustOverride Property FirstProperty() As String
    Public MustOverride Function FirstMethod(ByVal anArgument As String) As String
End Class

Public Class BasedOnAbstractTest
    Inherits AbstractTest

    Public Overrides Property FirstProperty() As String
        Get

        End Get
        Set(ByVal value As String)

        End Set
    End Property

    Public Overrides Function FirstMethod(ByVal anArgument As String) As String

    End Function
End Class

Public Class ImplementsITest
    Implements ITest

    Public Function FirstMethod() As Integer Implements ITest.FirstMethod

    End Function

    Public Function SecondMethod() As String Implements ITest.SecondMethod

    End Function

    Public Overrides Function ToString() As String Implements ITest.ToString
        Return MyBase.ToString
    End Function

End Class

Module Module1

    Sub Main()

    End Sub

End Module
