﻿'Important: The ExtensionMethod attribute is in this Namespace!
Imports System.Runtime.CompilerServices

'Important: The Namespace containing the Module with the extension 
'method for the related class has to be imported as well!
Imports ExtensionMethodDemo.MyExtensionMethod

Module MainModule

    Sub Main()

        Dim t = "This is the first line!\nAnd this is the second."
        Console.WriteLine(t.Formatted)

        'Auf Taste warten.
        Console.ReadKey()
    End Sub

End Module

Namespace MyExtensionMethod

    Module ExtensionMethodModule

        'The ExtensionMethodAttribute tags a method as extension method.
        'The type of the first argument sets the class/type to be extended.
        <Extension()> _
        Public Function Formatted(ByVal text As String) As String
            'Convert \n into CR+LF.
            Return text.Replace("\n", vbNewLine)
        End Function

    End Module
End Namespace


