﻿Imports <xmlns:Fleetns="http://vb2008.activedevelop.de/Fleet">

Module XmlWithLINQQueries

    Sub Demo()

        ' Define XML Element
        Dim Fleet = <?xml version="1.0"?>
                    <Fleetns:Fleet>
                        <Fleetns:Vehicle>
                            <Fleetns:LicencePlate>MS-VB 2010</Fleetns:LicencePlate>
                            <Fleetns:Manufacturer>Mack</Fleetns:Manufacturer>
                            <Fleetns:Load Amount="10000">Salt</Fleetns:Load>
                        </Fleetns:Vehicle>
                        <Vehicle>
                            <Fleetns:LicencePlate>MS-C# 2010</Fleetns:LicencePlate>
                            <Fleetns:Manufacturer>Mercedes-Benz</Fleetns:Manufacturer>
                            <Fleetns:Load Amount="20000">Peanuts</Fleetns:Load>
                        </Vehicle>
                        <Vehicle>
                            <Fleetns:LicencePlate>MS-F# 2010</Fleetns:LicencePlate>
                            <Fleetns:Manufacturer>Peterbilt</Fleetns:Manufacturer>
                            <Fleetns:Load Amount="5000">Bobbleheads</Fleetns:Load>
                        </Vehicle>
                    </Fleetns:Fleet>

        Dim mackVehicles = From Vehicle In Fleet.<Fleetns:Fleet> _
                           Where Vehicle.<Fleetns:Manufacturer>.Value = "Mack"

        For Each Vehicle In mackVehicles
            Console.WriteLine(Vehicle)
        Next

        'Query all Vehicles with a load over 15000 lbs.
        'thus, checking attribute values.
        Dim heavyLoad = From Vehicle In Fleet.<Fleetns:Fleet> _
                            Where CDbl(Vehicle.<Fleetns:Vehicle>.<Fleetns:Load>.@Amount) > 15000

        Console.WriteLine("Heavy Load")
        For Each Vehicle In heavyLoad
            Console.WriteLine(Vehicle)
        Next
        Console.ReadKey()
    End Sub

End Module
