﻿Imports System.Data.Objects

Module Module1

    Sub Main()

        'In the examples we are using the connections string from App.Config.
        'Change the string in the section ConnectionStrings to adjust the examples
        'to your SQL Server instance. To this end, you just need to adjust the
        'provider ConnectionString within the whole ConnectionStrings.
        Dim awContext As New AWEntities()

        Dim suppliers = From supplier In awContext.Vendor _
                          Where supplier.Name.StartsWith("H") _
                          Order By supplier.Name

        'With this statement we can find out
        'which SQL text will be used.
        Console.WriteLine(CType(suppliers, ObjectQuery(Of Vendor)).ToTraceString)
        Console.WriteLine()


        For Each supplier In suppliers
            Console.WriteLine(supplier.AccountNumber & ": " & supplier.Name)
            Console.WriteLine(New String("="c, 70))

            'Deliver the products to each supplier
            For Each product In supplier.ProductVendor
                Console.Write("ID:" & product.ProductID & " ")
                Console.WriteLine("Name:" & product.Product.Name)
            Next
            Console.WriteLine()

        Next

        Console.WriteLine()
        Console.WriteLine("Press key to exit.")
        Console.ReadKey()
    End Sub

End Module
